#include <windows.h>




enum{EMF, TXT};
enum{BOXPOINT, CROSSPOINT};

//object types
#define QTYOBJECTTYPES 15
enum{POLYLINE, POLYGON, RECTANGLE, ELLIPSE, POLYBEZIER, ARC, CHORD, PIE, TEXT,
ROUNDRECT, EMETAFILE, PATH, CIRCLE, GRID, ARROW};


//leftbutton options
enum{LB_SELECT, LB_POLYLINE, LB_POLYGON,  LB_RECTANGLE, LB_POLYBEZIER, LB_ARC, LB_CHORD,
LB_PIE, LB_TEXT, LB_ROUNDRECT, LB_EMETAFILE, LB_ARRAY, LB_CIRCLE, LB_ELLIPSE, LB_MOVE,
LB_ROTATE, LB_ROTDYNAMIC, LB_TRIM, LB_MEASURE, LB_HORIZONTAL, LB_PARALLEL, LB_GRID,
LB_ARROW, LB_POINT };


//limits for polyline/polygon/polybezier
#define MAXQTYPOINTBUF 250
#define MAXPATHOBJECTS 250
#define TOOLBARHEIGHT 47

#define getdc hdc=GetDC(hWnd)
#define reldc ReleaseDC(hWnd,hdc)
#define min(a,b)  (((a) < (b)) ? (a) : (b))
#define PI 3.141592
#define CUSTOMBRUSH 8


LRESULT CALLBACK Toolbar(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);


//used to exchange data between WndProc and toolbar without globals
struct tbsubclass
{
HWND		hwndtext;
HWND 		htbedit;
HWND 		hWndProc;
int 		toolbarmessage;
BOOL 		tooltip;
HINSTANCE	hInstance;
};
typedef struct tbsubclass TBSUB;




struct pointdouble
{
double x;
double y;
};
typedef struct pointdouble POINTDOUBLE ;




struct rectarray
{
int		qtyacross;
int		qtydown;
int		angle;
int 	dx;
int 	dy;
};
typedef struct rectarray RECTARRAY;




struct textinfo
{
char 	*string;
BOOL	done;
};
typedef struct textinfo TEXTINFO;




struct metainfo
{
HENHMETAFILE 	hemf;
char 			*filename;
};
typedef struct metainfo METAINFO;



struct pathinfo
{
unsigned char  	*objtyp;	//object type (polyline or bezier)
unsigned char	*ppo;		//points per object
unsigned char	qtyobj;		//making up the path
POINTDOUBLE		firstpoint;
};
typedef struct pathinfo PATHINFO;



struct gridinfo
{
int 	qtyrow;
int 	qtycol;
int 	qtycells;
WNDPROC hwndprocold;
HWND 	*hedit;
char 	**string; //40 char max per string
BOOL	done;
BOOL 	newgrid;
};
typedef struct gridinfo GRIDINFO;



struct penbrushtext
{
unsigned char 	pentype;
unsigned long 	pencolor;
unsigned char	brushtype;
unsigned long 	brushcolor;
unsigned char 	fonttype;
int 			fontsize;
int				fontangle;	//(deg +/- 90) * 10
unsigned char 	*bits;		//custom brush
};
typedef struct penbrushtext PENBRUSHTEXT;




struct gdiobject
{
unsigned char	type;
unsigned char	qtypoints;
BOOL 			selected;
PENBRUSHTEXT	pbt;
POINTDOUBLE		*point;

TEXTINFO		*text;
METAINFO		*meta;
PATHINFO 		*path;
GRIDINFO		*grid;

struct gdiobject *prev;
struct gdiobject *next;
};
typedef struct gdiobject GDIOBJECT;







