#include <windows.h>
#include <stdio.h>
#include "metapaintdefines.h"


//sprintf(buf,"%d",brush);
//SetWindowText(hWndProc, buf);
//MessageBox(NULL,buf,"",0);




/*
for the ToolbarSubclass() proc
the child windows have a particular (HMENU)id
that corresponds to the stringtable id numbers for tooltips

			(HMENU)	STRINGTABLE
polyline	0		500
polybezier	1		501
polygon		2		502
text		3		503
box zoom	4		504
message box	5		505
pentype		6		506
brushtype	7		507
fonttype	8		508
basiccolor	9		509
*/
static WNDPROC hwndold[10]; //window handles for subclassing, tooltips



BOOL CALLBACK ToolbarSubclass(HWND hWnd, UINT message,WPARAM wParam, LPARAM lParam);
unsigned char bitsum(unsigned char *pchar, int index_start);
void ShadePixel(HDC hdc, RECT *rect, POINT pMouse, unsigned char *squares, BOOL shade);
BOOL CALLBACK BitmapBrush(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void FillPaletteArray(COLORREF color[][512] );





#define XEXT 707
#define YEXT 20
#define QTYBASICCOLOR 13
#define COLORBANDHEIGHT 15
#define QTYBUTTON 5
#define QTYFONTSIZES 50
#define COMBOBOXHEIGHT 20
enum{ID_EDITBOX=5, ID_PENCOMBO, ID_BRUSHCOMBO, ID_FONTCOMBO, ID_COLORCOMBO, ID_TEXT, ID_ORTHO};





LRESULT CALLBACK Toolbar(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{

PAINTSTRUCT ps;
HDC hdc;
static HINSTANCE hInstance;
static TBSUB *ptr_tbe;
POINT pMouse, pMouse_log;
static HBITMAP hbitmap[QTYBUTTON];
HBITMAP hbitmap_brush;
static PENBRUSHTEXT *pbt;
HBRUSH hbrush;
HPEN hpen;
LPDRAWITEMSTRUCT pdis;
LPMEASUREITEMSTRUCT pmis;



static HWND htbedit;
HWND hWndbut[QTYBUTTON];
static HWND hwndpen, hwndbrush, hwndfont, hwndcolor, hwndtext;
static HWND hWndProc;
HWND hwndTB;



char buf[100];
static unsigned char bits[16];
static unsigned char char_in[64];



static int whichcolor; //value varies from 0-QTYBASICCOLOR
static int brush;
static int font;



COLORREF pixel;
static COLORREF colors[QTYBASICCOLOR][512];
static COLORREF pencolor, brushcolor;


//static RECT rbasiccolor[QTYBASICCOLOR];
static RECT cr;
RECT rect;


TBADDBITMAP tbab;
TBBUTTON tbb[5];
char *buttontext[5]={"Line", "Bezier", "Polygon", "Text", "Zoom"};







switch (message) {

default:
	return DefWindowProc(hWnd,message,wParam,lParam);
	break;

case WM_CREATE:
	hInstance = ((LPCREATESTRUCT)lParam)->hInstance;

	//get pointer to structure which stores current pen/brush/font parameters
	pbt =  (PENBRUSHTEXT *)((LPCREATESTRUCT)lParam)->lpCreateParams ;

	//initialize our pens and brushes
	pbt->pentype 		= 4;
	pbt->pencolor 		= pencolor 		= 0x0000ff ;
	pbt->brushtype		= 5;
	pbt->brushcolor 	= brushcolor	= 0x0000ff;
	pbt->fontsize 		= 20;
	pbt->fonttype 		= FF_ROMAN;
	pbt->fontangle		= 0;
	pbt->bits			= bits;




	GetClientRect(hWnd,&cr);

	//save a handle to the metaPaint parent window
	hWndProc = GetParent(hWnd);


	FillPaletteArray(colors);





	//draw buttons
	for(int i=0; i<QTYBUTTON; i++)
	{
		hWndbut[i] = CreateWindowEx(WS_EX_STATICEDGE, "button", "",
		WS_CHILD|WS_VISIBLE| BS_PUSHBUTTON | WS_CLIPCHILDREN|BS_BITMAP,
		26*i,5,26,26, hWnd, (HMENU)i, hInstance,NULL);

		hbitmap[i] = LoadBitmap(hInstance,MAKEINTRESOURCE(300+i)) ;
		SendMessage( hWndbut[i], BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hbitmap[i] );


		//subclass for tooltip
		hwndold[i] = (WNDPROC)GetWindowLong(hWndbut[i], GWL_WNDPROC);
		SetWindowLong(hWndbut[i], GWL_WNDPROC, (LONG)ToolbarSubclass);
	}





	//owner drawn pen combobox
	hwndpen = CreateWindow("combobox","" ,
		WS_CHILD | WS_VSCROLL | WS_VISIBLE |
		CBS_DROPDOWN | CBS_OWNERDRAWFIXED | CBS_SIMPLE,
		160,5,80,300,
		hWnd, (HMENU)ID_PENCOMBO, hInstance, NULL);
	SendMessage(hwndpen, CB_RESETCONTENT, 0, 0);
	//set pdis->itemData for each entry (32bit value)
	for(int i=0; i<14; i++)
		SendMessage(hwndpen, CB_ADDSTRING, 0, i );
	SendMessage(hwndpen, CB_SETCURSEL, 4, 0 );
	//subclass for tooltip
	hwndold[ID_PENCOMBO] = (WNDPROC)GetWindowLong(hwndpen, GWL_WNDPROC);
	SetWindowLong(hwndpen, GWL_WNDPROC, (LONG)ToolbarSubclass);





	//owner drawn brush combobox
	hwndbrush = CreateWindow("combobox","" ,
		WS_CHILD | WS_VSCROLL | WS_VISIBLE |
		CBS_DROPDOWN | CBS_OWNERDRAWFIXED | CBS_SIMPLE,
		250,5,80,300,
		hWnd, (HMENU)ID_BRUSHCOMBO, hInstance, NULL);
	SendMessage(hwndbrush, CB_RESETCONTENT, 0, 0);
	//set pdis->itemData for each entry (32bit value)
	for(int i=0; i<9; i++)
		SendMessage(hwndbrush, CB_ADDSTRING, 0, i );
	SendMessage(hwndbrush, CB_SETCURSEL, 5, 0 );
	//subclass for tooltip
	hwndold[ID_BRUSHCOMBO] = (WNDPROC)GetWindowLong(hwndbrush, GWL_WNDPROC);
	SetWindowLong(hwndbrush, GWL_WNDPROC, (LONG)ToolbarSubclass);





	//owner drawn font combobox
	hwndfont = CreateWindow("combobox","" ,
		WS_CHILD | WS_VSCROLL | WS_VISIBLE |
		CBS_DROPDOWN | CBS_OWNERDRAWFIXED | CBS_SIMPLE,
		340,5,80,300,
		hWnd, (HMENU)ID_FONTCOMBO, hInstance, NULL);
	SendMessage(hwndfont, CB_RESETCONTENT, 0, 0);
	//set pdis->itemData for each entry (32bit value)
	for(int i=0; i<8; i++)
		SendMessage(hwndfont, CB_ADDSTRING, 0, i );
	SendMessage(hwndfont, CB_SETCURSEL, 3, 0 );
	//subclass for tooltip
	hwndold[ID_FONTCOMBO] = (WNDPROC)GetWindowLong(hwndfont, GWL_WNDPROC);
	SetWindowLong(hwndfont, GWL_WNDPROC, (LONG)ToolbarSubclass);




	//owner drawn color combobox
	hwndcolor = CreateWindow("combobox","" ,
		WS_CHILD | WS_VSCROLL | WS_VISIBLE |
		CBS_DROPDOWN | CBS_OWNERDRAWFIXED | CBS_SIMPLE,
		430,5,80,300,
		hWnd, (HMENU)ID_COLORCOMBO, hInstance, NULL);
	SendMessage(hwndcolor, CB_RESETCONTENT, 0, 0);
	//set pdis->itemData for each entry (32bit value)
	for(int i=0; i<QTYBASICCOLOR; i++)
		SendMessage(hwndcolor, CB_ADDSTRING, 0, colors[i][256] );
	SendMessage(hwndcolor, CB_SETCURSEL, 0, 0 );
	//subclass for tooltip
	hwndold[ID_COLORCOMBO] = (WNDPROC)GetWindowLong(hwndcolor, GWL_WNDPROC);
	SetWindowLong(hwndcolor, GWL_WNDPROC, (LONG)ToolbarSubclass);





	//message (edit) box, our main tool for user input/feedback
	htbedit = CreateWindowEx(WS_EX_CLIENTEDGE, "edit", "",
			WS_CHILD|WS_VISIBLE|ES_LEFT,
			530,20,175,22,
			hWnd, (HMENU)ID_EDITBOX, hInstance,NULL);
	SendMessage(htbedit, WM_SETFONT, (WPARAM)GetStockObject(ANSI_FIXED_FONT), 0);
	//set window handle to edit box
	ptr_tbe = (TBSUB *)GetWindowLong(hWndProc,GWL_USERDATA);
	ptr_tbe->htbedit = htbedit;
	//subclass for tooltip and ENTER key
	hwndold[ID_EDITBOX] = (WNDPROC)GetWindowLong(htbedit, GWL_WNDPROC);
	SetWindowLong(htbedit, GWL_WNDPROC, (LONG)ToolbarSubclass);





	//static window for text messages above edit box
	hwndtext = CreateWindow("static", "",
			WS_CHILD|WS_VISIBLE,
			530,0,250,20,
			hWnd, (HMENU)ID_TEXT, hInstance,NULL);
	SendMessage(hwndtext, WM_SETFONT, (WPARAM)GetStockObject(ANSI_VAR_FONT), 0);
	ptr_tbe->hwndtext = hwndtext;

	break;





//paint our owner drawn combo boxes
case WM_DRAWITEM:
	pdis = (LPDRAWITEMSTRUCT) lParam;


	switch(pdis->itemAction) {
	case ODA_DRAWENTIRE: //show all entries in the dropdown state


	//pen combobox
	if(wParam==ID_PENCOMBO)
	{
		if(pdis->itemData==0)
			SelectObject(pdis->hDC,CreatePen(PS_DASH, 1, pencolor));

		else if(pdis->itemData==1)
			SelectObject(pdis->hDC,CreatePen(PS_DOT, 1, pencolor));

		else if(pdis->itemData==2)
			SelectObject(pdis->hDC,CreatePen(PS_DASHDOT, 1, pencolor));

		else if(pdis->itemData==3)
			SelectObject(pdis->hDC,CreatePen(PS_DASHDOTDOT, 1, pencolor));

		else if(pdis->itemData==4)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 1, pencolor));

		else if(pdis->itemData==5)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 2, pencolor));

		else if(pdis->itemData==6)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 3, pencolor));

		else if(pdis->itemData==7)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 4, pencolor));

		else if(pdis->itemData==8)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 5, pencolor));

		else if(pdis->itemData==9)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 6, pencolor));

		else if(pdis->itemData==10)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 7, pencolor));

		else if(pdis->itemData==11)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 10, pencolor));

		else if(pdis->itemData==12)
			SelectObject(pdis->hDC,CreatePen(PS_SOLID, 15, pencolor));


		if(pdis->itemData==13)
		{
			//the word "null"
			SelectObject(pdis->hDC, GetStockObject(ANSI_VAR_FONT));
			TextOut(pdis->hDC, pdis->rcItem.left+2, pdis->rcItem.top+2, "NULL",4);
		}
		else
		{
			//draw a line
			CopyRect(&rect, &pdis->rcItem);
			InflateRect(&rect, -2, -2);

			MoveToEx(pdis->hDC, rect.left, rect.bottom/2 + rect.top/2, NULL);
			LineTo(pdis->hDC, rect.right, rect.bottom/2 + rect.top/2);

			DeleteObject(SelectObject(pdis->hDC,GetStockObject(BLACK_PEN)));
		}
	}//end of drawing pen combobox






	//brush combobox
	if(wParam==ID_BRUSHCOMBO)
	{
		if(pdis->itemData==0)
			SelectObject(pdis->hDC, CreateHatchBrush(HS_HORIZONTAL, brushcolor ));

		else if(pdis->itemData==1)
			SelectObject(pdis->hDC, CreateHatchBrush(HS_VERTICAL, brushcolor ));

		else if(pdis->itemData==2)
			SelectObject(pdis->hDC, CreateHatchBrush(HS_FDIAGONAL, brushcolor ));

		else if(pdis->itemData==3)
			SelectObject(pdis->hDC, CreateHatchBrush(HS_BDIAGONAL, brushcolor ));

		else if(pdis->itemData==4)
			SelectObject(pdis->hDC, CreateHatchBrush(HS_CROSS, brushcolor ));

		else if(pdis->itemData==5)
			SelectObject(pdis->hDC, CreateHatchBrush(HS_DIAGCROSS, brushcolor ));

		else if(pdis->itemData==6)
			SelectObject(pdis->hDC, CreateSolidBrush( brushcolor ));


		if(pdis->itemData==7)
		{
			//the word "null"
			SelectObject(pdis->hDC, GetStockObject(ANSI_VAR_FONT));
			TextOut(pdis->hDC, pdis->rcItem.left+2, pdis->rcItem.top+2, "NULL",4);
		}

		else if(pdis->itemData==CUSTOMBRUSH)
		{
			//custom brush
			SelectObject(pdis->hDC, GetStockObject(ANSI_VAR_FONT));
			TextOut(pdis->hDC, pdis->rcItem.left+2, pdis->rcItem.top+2, "CUST",4);

			//display the brush after the word
			SetTextColor(pdis->hDC, 0x0 );
			SetBkColor(pdis->hDC, 0xffffff );
			hbitmap_brush = CreateBitmap(8,8,1,1, (unsigned char*)bits);
			SelectObject(pdis->hDC, CreatePatternBrush( hbitmap_brush ));
			SelectObject(pdis->hDC, GetStockObject(BLACK_PEN));

			Rectangle(pdis->hDC, pdis->rcItem.left+40, pdis->rcItem.top+2,
								pdis->rcItem.right-2, pdis->rcItem.bottom-2);

			DeleteObject(SelectObject(pdis->hDC,GetStockObject(BLACK_BRUSH)));
			DeleteObject(hbitmap_brush);
		}

		else
		{
			//draw a filled rect
			CopyRect(&rect, &pdis->rcItem);
			InflateRect(&rect, -2, -2);

			SelectObject(pdis->hDC, GetStockObject(NULL_PEN));
			Rectangle(pdis->hDC, rect.left, rect.top, rect.right, rect.bottom);

			DeleteObject(SelectObject(pdis->hDC,GetStockObject(BLACK_BRUSH)));
		}

	}//end of brush combobox






	//font combobox
	if(wParam==ID_FONTCOMBO)
	{
		SetBkMode(pdis->hDC, TRANSPARENT);
		SetTextColor(pdis->hDC, 0x0);


		if(pdis->itemData == 0)
		{
			SelectObject(pdis->hDC, CreateFont(15 ,0,0,0,0,FALSE,FALSE,FALSE,
						DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY, FF_DECORATIVE, ""));

			strcpy(buf,"Decorative");
		}

		else if(pdis->itemData == 1)
		{
			SelectObject(pdis->hDC, CreateFont(15 ,0,0,0,0,FALSE,FALSE,FALSE,
						DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY, FF_DONTCARE, ""));

			strcpy(buf,"Dontcare");
		}

		else if(pdis->itemData == 2)
		{
			SelectObject(pdis->hDC, CreateFont(15 ,0,0,0,0,FALSE,FALSE,FALSE,
						DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY, FF_MODERN, ""));

			strcpy(buf,"Modern");
		}

		else if(pdis->itemData == 3)
		{
			SelectObject(pdis->hDC, CreateFont(15 ,0,0,0,0,FALSE,FALSE,FALSE,
						DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY, FF_ROMAN, ""));

			strcpy(buf,"Roman");
		}

		else if(pdis->itemData == 4)
		{
			SelectObject(pdis->hDC, CreateFont(15 ,0,0,0,0,FALSE,FALSE,FALSE,
						DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY, FF_SCRIPT, ""));

			strcpy(buf,"Script");
		}

		else if(pdis->itemData == 5)
		{
			SelectObject(pdis->hDC, CreateFont(15 ,0,0,0,0,FALSE,FALSE,FALSE,
						DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY, FF_SWISS, ""));

			strcpy(buf,"Swiss");
		}

		else if(pdis->itemData == 6)
		{
			SelectObject(pdis->hDC,GetStockObject(ANSI_FIXED_FONT));
			strcpy(buf,"ANSI_fixed");
		}


		else if(pdis->itemData == 7)
		{
			SelectObject(pdis->hDC,GetStockObject(ANSI_VAR_FONT));
			strcpy(buf,"ANSI_var");
		}



		DrawText(pdis->hDC, buf, strlen(buf), &pdis->rcItem,
				DT_LEFT | DT_SINGLELINE | DT_VCENTER);


		//cleanup
		if(	pdis->itemData < 6 )
			DeleteObject(SelectObject(pdis->hDC, GetStockObject(ANSI_VAR_FONT)));

	}//end of font combobox





	//basic color combobox
	if(wParam==ID_COLORCOMBO)
	{
		hbrush = CreateSolidBrush( pdis->itemData );
		CopyRect(&rect, &pdis->rcItem);
		InflateRect(&rect, -2, -2);
		FillRect(pdis->hDC, &rect, hbrush);
		DeleteObject(hbrush);
	}





	break; //end of case ODA_DRAWENTIRE



	case ODA_SELECT:
		//draws a thin black border around the selection under the mouse
		if(pdis->itemState & ODS_SELECTED) //1
			hbrush = GetStockObject(BLACK_BRUSH);
		else
			hbrush = GetStockObject(WHITE_BRUSH);

		FrameRect(pdis->hDC, &pdis->rcItem, hbrush);
		break;
	}
	break;








case WM_PAINT:
	hdc=BeginPaint(hWnd, &ps);


	//display the first 256 colors
	for (int j=0; j<256; j++)
	{
    	SetRect(&rect, j, TOOLBARHEIGHT-COLORBANDHEIGHT, j+1, TOOLBARHEIGHT );
   		hbrush = CreateSolidBrush( colors[whichcolor][j] );
   		FillRect(hdc, &rect, hbrush);
   		DeleteObject(hbrush);
	}


	//display the next 256 colors
	for (int j=0; j<256; j++)
	{
    	SetRect(&rect, j+256, TOOLBARHEIGHT-COLORBANDHEIGHT, j+257, TOOLBARHEIGHT );
   		hbrush = CreateSolidBrush( colors[whichcolor][j+256] );
   		FillRect(hdc, &rect, hbrush);
   		DeleteObject(hbrush);
	}


	EndPaint(hWnd, &ps);
	break;




case WM_DESTROY:
	for(int i=0; i<QTYBUTTON; i++)
	DeleteObject(hbitmap[i]);
	break;





case WM_LBUTTONDOWN:
	pMouse.x=LOWORD(lParam);
	pMouse.y=HIWORD(lParam);


	//selected pen color
	if(pMouse.x < 513)
	{
		getdc;
		pencolor=GetPixel(hdc,pMouse.x,pMouse.y);
		reldc;
		pbt->pencolor = pencolor;
	}

	//repaint cuurent pen selection with new pen color
	SendMessage(hwndpen, CB_SETCURSEL, SendMessage(hwndpen, CB_GETCURSEL, 0,0),0);

	InvalidateRect(hWnd,NULL,FALSE);
	break;





case WM_RBUTTONDOWN:
	pMouse.x=LOWORD(lParam);
	pMouse.y=HIWORD(lParam);

	//selected brush color
	if(pMouse.x < 513)
	{
		getdc;
		brushcolor=GetPixel(hdc,pMouse.x,pMouse.y);
		reldc;
		pbt->brushcolor = brushcolor;
	}

	//repaint cuurent brush selection with new brush color
	SendMessage(hwndbrush, CB_SETCURSEL, SendMessage(hwndbrush, CB_GETCURSEL, 0,0),0);

	InvalidateRect(hWnd,NULL,FALSE);
	break;










case WM_COMMAND:

	//this prevents the combos from keeping the input focus
	//if the user selects the drop down arrow when the box is in the drop down state
	if(HIWORD(wParam)==8)
	{
		SetFocus(hWndProc);
		return 1;
	}



	switch(LOWORD(wParam))
	{
		case 0: //polyline button
			SendMessage(hWndProc, WM_COMMAND, 220, 0);
			break;


		case 1: //polybezier button
			SendMessage(hWndProc, WM_COMMAND, 221, 0);
			break;


		case 2: //polygon button
			SendMessage(hWndProc, WM_COMMAND, 222, 0);
			break;


		case 3: //text button
			SendMessage(hWndProc, WM_COMMAND, 223, 0);
			break;


		case 4: //box zoom button
			SendMessage(hWndProc, WM_COMMAND, 267, 0);
			break;



		case ID_PENCOMBO: //pen combobox

			if(HIWORD(wParam)==CBN_SELCHANGE)
			{
				pbt->pentype = SendMessage(hwndpen, CB_GETCURSEL, 0,0);
				SetFocus(hWndProc);
			}
			break;



		case ID_BRUSHCOMBO: //brush combobox

			if(HIWORD(wParam)==CBN_SELCHANGE)
			{
				pbt->brushtype = brush = SendMessage(hwndbrush, CB_GETCURSEL, 0,0);

				//custom brush
				if(brush == CUSTOMBRUSH)
				{
					DialogBoxParam(hInstance, MAKEINTRESOURCE(400), hWnd,
					(DLGPROC)BitmapBrush, (LPARAM)&char_in);


					//pattern brush bits must be padded on WORD boundry
					bits[0]  = bitsum(char_in, 0);
					bits[1]  = 0;
					bits[2]  = bitsum(char_in, 8);
					bits[3]  = 0;
					bits[4]  = bitsum(char_in, 16);
					bits[5]  = 0;
					bits[6]  = bitsum(char_in, 24);
					bits[7]  = 0;
					bits[8]  = bitsum(char_in, 32);
					bits[9]  = 0;
					bits[10] = bitsum(char_in, 40);
					bits[11] = 0;
					bits[12] = bitsum(char_in, 48);
					bits[13] = 0;
					bits[14] = bitsum(char_in, 56);
					bits[15] = 0;
				}

			SetFocus(hWndProc);
			}
			break;




		case ID_FONTCOMBO: //fonttype combobox

			if(HIWORD(wParam)==CBN_SELCHANGE)
			{
				font = SendMessage(hwndfont, CB_GETCURSEL, 0,0);

				if(font == 0)
					pbt->fonttype = FF_DECORATIVE;

				else if (font == 1)
					pbt->fonttype = FF_DONTCARE;

				else if (font == 2)
					pbt->fonttype = FF_MODERN;

				else if (font == 3)
					pbt->fonttype = FF_ROMAN;

				else if (font == 4)
					pbt->fonttype = FF_SCRIPT;

				else if (font == 5)
					pbt->fonttype = FF_SWISS;

				else if (font == 6)
					pbt->fonttype = ANSI_FIXED_FONT;

				else
					pbt->fonttype = ANSI_VAR_FONT;


				SetFocus(hWndProc);
			}
			break;



		case ID_COLORCOMBO: //basic color combobox
			if(HIWORD(wParam)==CBN_SELCHANGE)
			{
				whichcolor = SendMessage(hwndcolor, CB_GETCURSEL, 0,0);
				InvalidateRect(hWnd,NULL,FALSE);
			}
			break;



	}

	break; //end wm_command




}//end switch (message)
return 0;
}//end WndProc








/*******************************************************************
function fills in a 2 dimensional COLORREF array
create the array[13][512] in your calling program and pass the address
the colors are stored dark to light
you need 512 pixels to display the full bands
e.g. color_array[0][0]   is black 0,0,0
e.g. color_array[0][256] is pure red 255,0,0, this is the "basic" color
e.g. color_array[0][512] is pure white 255,255,255
********************************************************************/
void FillPaletteArray(COLORREF color[][512] )
{
// fill the dark bands
//j=0 is black,  j=255 is basic color
for (int j=0; j<256; j++)
{
	//					  basic colors:
	color[0][j] = RGB(j, 	0, 		0) ;		//red 255,0,0
	color[1][j] = RGB(j, 	j/2, 	0);			//orange 255,127,0
	color[2][j] = RGB(j, 	j, 		0) ;		//yellow 255,255,0
	color[3][j] = RGB(0, 	j, 		0) ;		//green 0,255,0
	color[4][j] = RGB(0, 	j/2, 	0 ); 	 	//dgreen  0,128,0
	color[5][j] = RGB(j/4, 	j/2, 	j/2 );  	//bluegreen 64,127,127
	color[6][j] = RGB(0, 	j, 		j) ;		//sky blue 0,255,255
	color[7][j] = RGB(0, 	0, 		j) ;		//blue 0,0,255
	color[8][j] = RGB(j, 	0, 		j) ;		//pink 255,0,255
	color[9][j] = RGB(j/2, 	0, 		(2*j)/3 );	//purple 127,0,170
	color[10][j]= RGB(j/2, 	0, 		j/4 );  	//burgundy 128,0,64
	color[11][j]= RGB(j/2,	j/3, 	j/6 );  	//brown 127,85,42
	color[12][j]= RGB(j/2,	j/2, 	j/2 );  	//gray 127,127,127


}

//fill the light bands
//j=0 is the basic color, j=255 is white
for (int j=0; j<256; j++)
{
	color[0][j+256] = RGB(255, 		j, 			j) ;
	color[1][j+256] = RGB(255, 		127+j/2, 	j) ;
	color[2][j+256] = RGB(255, 		255, 		j) ;
	color[3][j+256] = RGB(j, 		255, 		j) ;
	color[4][j+256] = RGB(j, 		127+j/2, 	j );
	color[5][j+256] = RGB(64+3*j/4, 127+j/2, 	127+j/2 );
	color[6][j+256] = RGB(j, 		255, 		255) ;
	color[7][j+256] = RGB(j, 		j, 			255) ;
	color[8][j+256] = RGB(255, 		j, 			255) ;
	color[9][j+256] = RGB(127+j/2, 	j, 			170+j/3 ) ;
	color[10][j+256]= RGB(127+j/2, 	j, 			64+3*j/4 );
	color[11][j+256]= RGB(127+j/2,	85+2*j/3, 	42+5*j/6 );
	color[12][j+256]= RGB(127+j/2,	127+j/2, 	127+j/2 );
}
}








//function packs 8 consecutive bits into 1 unsigned char
unsigned char bitsum(unsigned char *pchar, int index_start)
{
unsigned char ctemp=0;

for(int i=0; i<8; i++)
{
	ctemp = ctemp | (pchar[i+index_start] << (7-i) ) ;
}
return ctemp;
}







//  1=00000001
//127=01111111
//128=10000000
//254=11111110


BOOL CALLBACK BitmapBrush(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
PAINTSTRUCT ps;
static unsigned char *squares;
POINT pMouse;
static RECT rect[64];
HDC hdc;

switch ( message )
{
case WM_INITDIALOG:
	//get pointer to array describing state of each square in 8x8 grid
	//0=selected  1=not selected
	squares = (unsigned char *) lParam ;

	memset(squares, 1, 64);
	for(int i=0; i<8; i++)
	for(int j=0; j<8; j++)
	SetRect( &rect[j+(i*8)], j*20, i*20, (j+1)*20, (i+1)*20 );

	break;




case WM_PAINT:
	hdc=BeginPaint(hWnd, &ps);

	SelectObject(hdc,GetStockObject(WHITE_BRUSH));
	SelectObject(hdc,GetStockObject(NULL_PEN));

	for(int i=0; i<64; i++)
	Rectangle(hdc, rect[i].left, rect[i].top, rect[i].right, rect[i].bottom);

	EndPaint(hWnd, &ps);
	return 0;


case WM_LBUTTONDOWN:
	pMouse.x=LOWORD(lParam);
	pMouse.y=HIWORD(lParam);
	getdc;
	ShadePixel(hdc, rect, pMouse, squares, TRUE);
	reldc;
	return 0;


case WM_RBUTTONDOWN://erase
	pMouse.x=LOWORD(lParam);
	pMouse.y=HIWORD(lParam);
	getdc;
	ShadePixel(hdc, rect, pMouse, squares, FALSE);
	reldc;
	return 0;


case WM_COMMAND:
	if(wParam == IDCANCEL)
	EndDialog( hWnd, FALSE );
	break;

}
return FALSE;
}






void ShadePixel(HDC hdc, RECT *rect, POINT pMouse, unsigned char *squares, BOOL shade)
{

SelectObject(hdc, GetStockObject(NULL_PEN));
for(int i=0; i<64; i++)
{
	if( PtInRect( &rect[i], pMouse) )
	{
		if(shade)
		{
			SelectObject(hdc, GetStockObject(BLACK_BRUSH));
			squares[i] = 0;
		}
		else//erase
		{
			SelectObject(hdc,GetStockObject(WHITE_BRUSH));
			squares[i] = 1;
		}

		Rectangle(hdc, rect[i].left, rect[i].top, rect[i].right, rect[i].bottom);
	}
}
}






BOOL CALLBACK ToolbarSubclass(HWND hWnd, UINT message,WPARAM wParam, LPARAM lParam)
{
char buf[150];
char space[150]; memset(space, ' ', 150);


//get (HMENU)id of child window
int id = GetWindowLong(hWnd, GWL_ID);

//window handle of container window for buttons, comboboxes...
HWND hwndtb = GetParent(hWnd);

//our main window handle
HWND hWndProc = GetParent(hwndtb);

//pointer to our toolbar struct set in WndProc wm_create
TBSUB *ptr_tbe = (TBSUB *)GetWindowLong(hWndProc,GWL_USERDATA);




//process return key after values entered in message box (right of buttons)
if(id==ID_EDITBOX && message==WM_KEYDOWN && wParam==VK_RETURN && ptr_tbe->toolbarmessage!=0)
{
	SetFocus(ptr_tbe->hWndProc);
	SendMessage(ptr_tbe->hWndProc, ptr_tbe->toolbarmessage, 0,0);
}



//display tooltip when mouse is over child window
if(message==WM_SETCURSOR && ptr_tbe->tooltip)
{
	HDC hdc = GetDC(hWndProc);

	//load tooltip
	LoadString(ptr_tbe->hInstance, 500+id,  buf, 99);
	strncat(buf, space, 149-strlen(buf));

	TextOut(hdc, 30, 70, buf, 149);

	ReleaseDC(hWndProc, hdc);
}



return CallWindowProc( hwndold[id], hWnd, message,wParam,lParam);
}

